B - Pie HDU - 1969 (二分)

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though. 

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different. 
InputOne line with a positive integer: the number of test cases. Then for each test case: 
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends. 
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies. 
OutputFor each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
Sample Output
25.1327
3.1416
50.2655

AC代码:

#include<cmath>
#include<cstdio>
#include<string>
#include<iostream>
#include<algorithm>
using namespace std;
#define PI acos(-1.0)//精确的PI
const int maxn = 1e4+5;
int main()
{
	int t;
	cin>>t;
	while(t--){
		int n,m,b;
		double a[maxn];
		double low = 0.0,high = 0.0,mid;
		scanf("%d %d",&n,&m);
		for(int i = 0;i<n;i++){
			scanf("%d",&b);
			a[i] = b*b*PI;
			high = high + a[i];
		}
		m++;
		high /= m;
		while(high - low > 1e-5){
			mid = (low + high) / 2;
			int ss = 0;
			for(int i = 0;i<n;i++){
				ss += (int)(a[i]/mid);
			}
			if(ss>=m) low = mid; 
			else high = mid;
		}
		printf("%.4lf\n",low);
	}
	return 0;
}

/****
题目大意:
第一行一个T代表有T组数据
每组数据第一行有两个数n和f,
每组数据第二行n个数表示每个pie的半径
求每个人能分到的最大蛋糕体积,不能几块蛋糕拼成一块(带上自己有f+1个人)。
输入: 
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
输出: 
25.1327
3.1416
50.2655
****/
/* 
思路:这个题就是用比较简单的二分法,二分法需要注意的有两点,一是以何值为二分的对象(一般都是要求的量)
,二是判断的条件(这往往是问题的关键)。在此题中,二分的对象很显然是每个人可以分到的pie体积,
接着判断每块蛋糕可已分成几块这样大小的pie,记录和,最后判断和与人数的大小,进行高低点的移动,
从而达到条件退出循环。
*/

/*
别人家的好代码
#include<stdio.h>  
#include<math.h>  
#define MAX 10001  
#define PI acos(-1.0);//精确度提高。  
int main()  
{  
    int num,n,f,r,i,sum;  
    double low,high,mid,v[MAX];  
    scanf("%d",&num);  
    while(num--)  
    {  
        scanf("%d%d",&n,&f);  
        low=0;  
        high=0;  
        for(i=0;i<n;i++)  
        {  
            scanf("%d",&r);  
            v[i]=r*r*PI;  
            high+=v[i];  
        }  
        f+=1;//包括自己.  
        high/=f;  
        while(high-low>=1e-7)  
        {  
            sum=0;  
            mid=(low+high)/2.0;  
            for(i=0;i<n;i++)  
                sum+=(int)(v[i]/mid);//记录可以分成多少块。  
            if(sum>=f)  
                low=mid;  
            else  
                high=mid;  
        }  
        printf("%.4f\n",mid);  
    }  
    return 0;    
} 
*/ 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值